/////////////////////////////////////////////////////////////
/// convert9 0.0.3 initial public Alpha
///          0.0.4 corrects IDNI numbers
///          0.0.5 corrects Education error
///                Adds HEAD tag 1 SOUR -> 2 NAME, 2 VERS 
///                Adds versioning 
///          0.0.6 Adds TRLR tag     
///                Adds Head tag 1 DEST, 1 FILE
///                Adds Family writing                 
///                Adds Passing file name by arguement.
///                Up individual and families to 500
///          0.1.0 updates for stop9 1.1
///                fixes firstname space
///                Family writing completely redone
///          0.1.1 updates for stop9 1.1
/// By Michael Gibson
/// (c)2003 
/// Code under GPL
/// Part of the Gibson's GEDCOM Tools
/// Converts stop9 format to GEDCOM
//////////////////////////////////////////////////////////////
#include <stdio.h>

char *r_version="0.1.0";

void read_data(void);
void write_i_data(void);
void write_f_data(void);
void write_c_data(void);

int  idnum[500];
char firstname[500][50];
char surname[500][50];
char sex[500][7];
char birth_date[500][50];
char birth_place[500][70];
char death_date[500][50];
char death_place[500][70];
char burial_place[500][70];
char occupation[500][70];
char education[500][70];
char religon[500][70];
int  father[500];
int  mother[500];
int  married[500];

int num_of_entries;
char filename[50];

int stop9;

int main(int argc, char **argv)
{

  if(argc==2){
    sprintf(filename,"%s",argv[1]);
    printf("%s = filename\n",filename);
  }
  else{
    sprintf(filename,"temp.ged");
    printf("%s = filename\n",filename);
  }

  read_data();
  write_i_data();
  write_f_data();
  write_c_data();
  return(0);
}

/////////////////////////////
/// read data
/////////////////////////////
void read_data()
{
  int x=0;
  FILE *filedatap;

  filedatap=fopen("idata.in","r");
  printf("Input file opened....\n\n");
  do{
    x++;

    fscanf(filedatap,"%d%s%s%s%s%s",&idnum[x],firstname[x],surname[x],sex[x],birth_date[x],birth_place[x]);

    if(strstr(firstname[x],"stop9") == '\0') printf("Name read: %s %s \n",firstname[x],surname[x]);

    fscanf(filedatap,"%s%s%s%s%s",death_date[x],death_place[x],burial_place[x]);
    fscanf(filedatap,"%s%s%s",education[x],occupation[x],religon[x]);
    fscanf(filedatap,"%d%d%d",&father[x],&mother[x],&married[x]);


  }while(firstname[x][4] != '9' );

  printf("\nInput file read....\nNumber of lines read =%d\n",x);
  num_of_entries=x;
  fclose(filedatap);
  printf("Input file closed...\n");
  stop9=x;
}

/////////////////////////
/// write individual data
////////////////////////
void write_i_data()
{
  int x;
  int loop;

  FILE *fp;
  
  fp=fopen(filename,"w+");

/// Heading
  fprintf(fp,"0 HEAD\n");
  fprintf(fp,"1 SOUR MRGIBSON.COM\n");
  fprintf(fp,"2 NAME Convert9\n");
  fprintf(fp,"2 VERS %s\n",r_version);
  fprintf(fp,"1 DEST ANSTFILE\n");
  fprintf(fp,"1 CHAR ANSI\n");
  fprintf(fp,"1 FILE %s\n",filename);
  fprintf(fp,"1 GEDC\n");
  fprintf(fp,"2 VERS 5.5\n");
  fprintf(fp,"2 FORM LINEAGE-LINKED\n");

  printf("\n\nGEDCOM Heading written....\n\n");

/// Individual 
  for(x=1;x< num_of_entries;x++){
    printf("writting INDI I%04d \n",idnum[x]);
    if(firstname[x][0]!='s' && firstname[x][4] != '9' && firstname[x][0]!='\0'){
      fprintf(fp,"0 @I%04d@ INDI\n",idnum[x]);
      for(loop=0;loop<=14;loop++){
       if(firstname[x][loop]=='*') firstname[x][loop]=' ';
      }
      fprintf(fp,"1 NAME %s /%s/\n",firstname[x],surname[x]);
      fprintf(fp,"1 SEX %c\n",sex[x][0]);
      fprintf(fp,"1 BIRT\n");
      for(loop=0;loop<=14;loop++){
        if(birth_date[x][loop]=='*') birth_date[x][loop]=' ';
      }
      if(birth_date[x][0]!='z'){
        fprintf(fp,"2 DATE %s\n",birth_date[x]);
      }
      for(loop=0;loop<=14;loop++){
       if(birth_place[x][loop]=='*') birth_place[x][loop]=' ';
      }
      if(birth_place[x][0]!='-'){
        fprintf(fp,"2 PLAC %s\n",birth_place[x]);
      }
      fprintf(fp,"1 DEAT\n");
      for(loop=0;loop<=14;loop++){
        if(death_date[x][loop]=='*') death_date[x][loop]=' ';
      }
      if(death_date[x][0]!='z'){
        fprintf(fp,"2 DATE %s\n",death_date[x]);
      }
      for(loop=0;loop<=44;loop++){
        if(death_place[x][loop]=='*') death_place[x][loop]=' ';
      }
      if(death_place[x][0]!='-'){
        fprintf(fp,"2 PLAC %s\n",death_place[x]);
      }
      if(burial_place[x][0]!='-'){
        fprintf(fp,"1 BURI\n");
      }
      if(burial_place[x][0]!='-'){
        fprintf(fp,"1 PLAC %s\n",burial_place[x]);
      }
      for(loop=0;loop<=70;loop++){
        if(education[x][loop]=='*') education[x][loop]=' ';
      }
      if(education[x][0]!='-'){
        fprintf(fp,"1 EDUC %s\n",education[x]);
      }
      for(loop=0;loop<=70;loop++){
        if(occupation[x][loop]=='*') occupation[x][loop]=' ';
      }
      if(occupation[x][0]!='-'){
        fprintf(fp,"1 OCCU %s\n",occupation[x]);
      }

      for(loop=0;loop<=70;loop++){
        if(religon[x][loop]=='*') religon[x][loop]=' ';
      }
      if(religon[x][0]!='-'){
        fprintf(fp,"1 RELI %s\n",religon[x]);
      }

      fprintf(fp,"1 FAMC @F%04d@\n",x);

      for(loop=1;loop<=stop9;loop++){
        if(idnum[x]==father[loop]){
              fprintf(fp,"1 FAMS @F%04d@\n",loop);
          }
      }
      for(loop=1;loop<=stop9;loop++){
        if(idnum[x]==mother[loop]){
           fprintf(fp,"1 FAMS @F%04d@\n",loop);
        }
      }
    }
  }

  fclose(fp);
  printf("done writing individuals\n");
}                                                                                                                             
////////////////////////////////////
/// family format
///////////////////////////////////
void write_f_data()
{

  FILE *fp;
  int x=0;
  int tempfatherid,tempmotherid;

  fp=fopen(filename,"a");

  do{
    x++;
    fprintf(fp,"0 @F%04d@ FAM\n",x);
    if(father[x] != 0) fprintf(fp,"1 HUSB @I%04d@\n",father[x]);
    if(mother[x] != 0) fprintf(fp,"1 WIFE @I%04d@\n",mother[x]);
    if(idnum[x] != '\0') fprintf(fp,"1 CHIL @I%04d@\n",idnum[x]);
  }while(x<=stop9);

  fclose(fp);

}

/////////////////////////
/// write close data
////////////////////////
void write_c_data()
{
                                                                                                                             
  FILE *fp;
                                                                                                                             
  fp=fopen(filename,"a");
                                                                                                                             
/// Close 
  fprintf(fp,"0 TRLR\n");

  fclose(fp);
}
