////////////////////////////////////////////////////
//// Written by Michael Gibson
//// Under the GPL
////
//// Creates Initial GEDCOM FILE
////////////////////////////////////////////////////
#include <stdio.h>
#include <time.h>

#ifdef WIN32
  #include "GDXlib\\GDXlib.h"
#endif

#ifndef WIN32
  #include <GDXlib/GDXlib.h>
#endif


char *r_version="0.2";

char *error_msg;

char *filename="family.ged";


int id_text;
int gn_text;
int sn_text;
int sx_text;
int db_text;
int bp_text;

int dd_text;
int dp_text;
int bl_text;

int ad_text;  //address
int oc_text;  //occupation
int ed_text;  //education


int gn2_text;
int sn2_text;
int db2_text;

int gn3_text;
int sn3_text;
int db3_text;

char string_time[6];
char string_date[12];

/////////////////////////////
// do my time
///////////////////////////
void do_my_time(void)
{

  size_t my_i_time;
  size_t my_i_date;
  struct tm my_time;
  struct tm my_date;
  time_t now;

  now = time(NULL);
  my_time = *(localtime(&now));
  my_date = *(localtime(&now));


  my_i_time = strftime(string_time,6,"%H:%M",&my_time);
  my_i_date = strftime(string_date,12,"%d %b %Y",&my_date);

  printf("'%s' '%s'\n ",string_time,string_date);

  puts(string_time);
  puts(string_date);

}



////////////////////////
//// name file
////////////////////////
void name_file () {
                                                                                                                             
   printf("%s filename",filename);

}

////////////////////////////////////
//// load report module
///////////////////////////////////
void l_report(void){

   char systemstring[50];

#ifdef WIN32
   sprintf(systemstring,".\\gdx_gedreport %s -h &",filename);
#endif

#ifndef WIN32
   sprintf(systemstring,"./gdx_gedreport %s -h &",filename);
#endif

   system(systemstring);

}

////////////////////////
//// error message
////////////////////////
void quick_message(void) {

  x_msgbox(5,error_msg,"Error","fixed",50);

}

//////////////////////
/// write data
/////////////////////
void writedata()
{
  FILE *fp6;

char givenname1[50]={'\0'};
char surname1[50]={'\0'};
char gender1[5]={'\0'};
char birthday1[50]={'\0'};
char birthplac1[50]={'\0'};
char deathdate1[50]={'\0'};
char deathplac1[50]={'\0'};
char burialplac1[50]={'\0'};
char address1[50]={'\0'};
char occupation1[50]={'\0'};
char education1[50]={'\0'};

char givenname2[50]={'\0'};
char surname2[50]={'\0'};
char birthday2[50]={'\0'};

char givenname3[50]={'\0'};
char surname3[50]={'\0'};
char birthday3[50]={'\0'};

  do_my_time();

  printf("*** %s filename\n",filename);
  //filename =  gtk_entry_get_text ( (file_text));
  printf("*** %s filename\n",filename);

  strcpy(givenname1 , gdx_textentry_obj.string[gn_text]);
  strcpy(surname1   , gdx_textentry_obj.string[sn_text]);
  strcpy(gender1    , gdx_textentry_obj.string[sx_text]);
  strcpy(birthday1  , gdx_textentry_obj.string[db_text]);
  strcpy(birthplac1 , gdx_textentry_obj.string[bp_text]);

  strcpy(deathdate1 , gdx_textentry_obj.string[dd_text]);
  strcpy(deathplac1 , gdx_textentry_obj.string[dp_text]);
  strcpy(burialplac1, gdx_textentry_obj.string[bl_text]);

  strcpy(address1,    gdx_textentry_obj.string[ad_text]);
  strcpy(occupation1, gdx_textentry_obj.string[oc_text]);
  strcpy(education1 , gdx_textentry_obj.string[ed_text]);

  strcpy(givenname2 , gdx_textentry_obj.string[gn2_text]);
  strcpy(surname2   , gdx_textentry_obj.string[sn2_text]);
  strcpy(birthday2  , gdx_textentry_obj.string[db2_text]);

  strcpy(givenname3 , gdx_textentry_obj.string[gn2_text]);
  strcpy(surname3   , gdx_textentry_obj.string[sn2_text]);
  strcpy(birthday3  , gdx_textentry_obj.string[db2_text]);

  printf("open file\n");

  fp6=fopen(filename,"w");

  printf("write header\n");

/// Heading
  fprintf(fp6,"0 HEAD \n");
  fprintf(fp6,"1 SOUR MRGIBSON.COM\n");
  fprintf(fp6,"2 VERS %s\n",r_version);
  fprintf(fp6,"2 NAME FirstData\n");
  fprintf(fp6,"1 DATE %s\n",string_date);
  fprintf(fp6,"2 TIME %s\n",string_time);
  fprintf(fp6,"1 DEST ANSTFILE"); 
  fprintf(fp6,"1 CHAR ANSI \n");
  fprintf(fp6,"1 FILE %s \n",filename);
  fprintf(fp6,"1 GEDC \n");
  fprintf(fp6,"2 VERS 5.5 \n");
  fprintf(fp6,"2 FORM LINEAGE-LINKED \n");

/// individual 1
  fprintf(fp6,"0 @I0001@ INDI\n");

  if(surname1[0]!='\0') fprintf(fp6,"1 NAME %s /%s/\n",givenname1,surname1);
  else{
     error_msg = "Could not write Name of ID '0001'.  You must enter a Surname.   This is a person's Last or Maiden name.";
     quick_message();
  }

  if(gender1[0]=='F' || gender1[0]=='M') fprintf(fp6,"1 SEX %1s\n",gender1);
  else{
     error_msg = "Could not write Gender/Sex of ID '0001'.  Valid entries are:  M for Male.  F for Female.";
     quick_message();
  }

  if(surname1[0]!='\0') fprintf(fp6,"1 BIRT\n");

  if(birthday1[0] >= 47 && birthday1[0]<= 56) fprintf(fp6,"2 DATE %s\n",birthday1);
  else{
     if(birthday1[0] != '\0'){
       error_msg = "Could not write Birth Date of ID '0001'.  Valid format is: DD MMM YYYY  Example: 10 Jan 1905";
       quick_message();
     }
  }

  if(surname1[0]!='\0' && birthplac1 != '\0') fprintf(fp6,"2 PLAC %s\n",birthplac1);
  if(surname1[0]!='\0' && deathdate1 != '\0') fprintf(fp6,"1 DEAT Y\n");
  if(surname1[0]!='\0' && deathdate1 != '\0') fprintf(fp6,"2 DATE %s\n",deathdate1);
  if(surname1[0]!='\0' && deathplac1 != '\0') fprintf(fp6,"2 PLAC %s\n",deathplac1);
  if(surname1[0]!='\0' && burialplac1!= '\0') fprintf(fp6,"1 BURI\n");
  if(surname1[0]!='\0' && burialplac1!= '\0') fprintf(fp6,"2 PLAC %s\n",burialplac1);

  if(surname1[0]!='\0' && address1 != '\0') fprintf(fp6,"1 ADDR %s\n",address1);
  if(surname1[0]!='\0' && occupation1 != '\0') fprintf(fp6,"1 OCCU %s\n",occupation1);
  if(surname1[0]!='\0' && education1 != '\0') fprintf(fp6,"1 EDUC %s\n",education1);

  if(surname1[0]!='\0') fprintf(fp6,"1 FAMC @F0001@\n");

/// individual 2 father
  fprintf(fp6,"0 @I0002@ INDI\n");
  if(surname2[0]!='\0') fprintf(fp6,"1 NAME %s /%s/\n",givenname2,surname2);
  if(surname2[0]!='\0' || givenname2[0]!='\0') fprintf(fp6,"1 SEX M \n");
  if(surname2[0]!='\0' || givenname2[0]!='\0') fprintf(fp6,"1 BIRT \n");  
  if(birthday2[0] >= 47 && birthday2[0]<= 56) fprintf(fp6,"2 DATE %s\n",birthday2);
  if(surname2[0]!='\0' || givenname2[0]!='\0') fprintf(fp6,"1 FAMS @F0001@\n");

/// individual 3 mother
  fprintf(fp6,"0 @I0003@ INDI\n");
  if(surname3[0]!='\0') fprintf(fp6,"1 NAME %s /%s/ \n",givenname3,surname3);
  if(surname3[0]!='\0' || givenname3[0]!='\0') fprintf(fp6,"1 SEX F \n");
  if(surname3[0]!='\0' || givenname3[0]!='\0') fprintf(fp6,"1 BIRT \n");
  if(birthday3[0] >= 47 && birthday3[0]<= 56) fprintf(fp6,"2 DATE %s\n",birthday3);
  if(surname3[0]!='\0' || givenname3[0]!='\0') fprintf(fp6,"1 FAMS @F0001@\n");

/// family
  fprintf(fp6,"0 @F0001@ FAM\n");
  if(surname2[0]!='\0' || givenname2[0]!='\0') fprintf(fp6,"1 HUSB @I0002@\n");
  if(surname3[0]!='\0' || givenname3[0]!='\0') fprintf(fp6,"1 WIFE @I0003@\n");
  if(surname1[0]!='\0') fprintf(fp6,"1 CHIL @I0001@\n"); 

  fprintf(fp6,"0 TRLR\n");

  fclose(fp6);

  x_msgbox(5,"GEDCOM Data saved to file 'family.ged'.","gdx_firstdata","fixed",50);

}



////////////////////////
//// about message
////////////////////////
void about_message(void) {

   x_msgbox(5,"gdx_firstdata from http://mrgibson.com","gdx_firstdata","fixed",50);

}

//////////////////////////////////////
/// Another callback 
/////////////////////////////////////
void destroy()
{
    gdx_closewindow ();
}

/////////////////////////////////////
/// Clear Data
////////////////////////////////////

void cleardata()
{
  gdx_settextentry (gn_text, "\0");
  gdx_settextentry (sn_text, "\0");
  gdx_settextentry (sx_text, "\0");
  gdx_settextentry (db_text, "\0");
  gdx_settextentry (bp_text, "\0");
  gdx_settextentry (dd_text, "\0");
  gdx_settextentry (dp_text, "\0");
  gdx_settextentry (bl_text, "\0");
  gdx_settextentry (ad_text, "\0");  //address
  gdx_settextentry (oc_text, "\0");  //occupation
  gdx_settextentry (ed_text, "\0");  //education
  gdx_settextentry (gn2_text, "\0");
  gdx_settextentry (sn2_text, "\0");
  gdx_settextentry (db2_text, "\0");
  gdx_settextentry (gn3_text, "\0");
  gdx_settextentry (sn3_text, "\0");
  gdx_settextentry (db3_text, "\0");

}
///////////////////////////////////////
/// Main
////////////////////////////////////////
int main(int argc, char *argv[])
{
  int button1, button2, button3, button4, button5;
  int menubar;
  int menu1,menu2,menu3;
  int menuitem1_menu1, menuitem2_menu1, menuitem3_menu1;
  int menuitem1_menu2; 
  int menuitem1_menu3;

  printf("start gui\n");

  x_open();
    
  /* create a new window */
  gdx_window("Create New GEDCOM File",790,500);
  gdx_setwindowbg("bg.xpm",1 );


  /* create the widgets */


  //individual data
  gdx_frame(3,60,785,120,"Individual"); 

  gdx_label("ID #",8,85,0);
  gdx_label("0001",60,85,2);

  gdx_label("Given Name",100,85,0); 
  gn_text = gdx_textentry(200,70,180,0);

  gdx_label("Surname",400,85,0); 
  sn_text = gdx_textentry(510,70,200,0);

  gdx_label("Gender",8,110,0); 
  sx_text = gdx_textentry(60,95,17,0); 

  gdx_label("Date of Birth",100,110,0); 
  db_text = gdx_textentry(200,95,80,0);

  gdx_label("Location of Birth",400,110,0); 
  bp_text = gdx_textentry(510,95,250,0);

  //Personal information
  gdx_frame(3,160,785,220,"Personal Information");

  gdx_label("Address",8, 185,0);
  ad_text = gdx_textentry(75,170,305,0);

  gdx_label("Education",400, 185,0);
  ed_text = gdx_textentry(460,170,305,0);
  
  gdx_label("Occupation",8,210,0);
  oc_text = gdx_textentry(75,195,305,0);

  //Mortality Information
  gdx_frame(3,260,785,320,"Mortality Information");
  gdx_label("Date of Death",8,285,0);
  dd_text = gdx_textentry(108,270,95,0);
  gdx_label("Location of Death",218,285,0);
  dp_text = gdx_textentry(330,270,250,0);
  gdx_label("Burial Location",8,310,0);
  bl_text = gdx_textentry(108,295,250,0);


  //Father 
  gdx_frame(3,360,385,470,"Father");
  gdx_label("ID #",8,385,0);
  gdx_label("0002",60,385,2);

  gdx_label("Given Name",8,410,0);
  gn2_text = gdx_textentry(99,395,200,0);
  gdx_label("Surname",8,435,0);
  sn2_text = gdx_textentry(99,420,200,0);
  gdx_label("Date of Birth",8,460,0);
  db2_text = gdx_textentry(99,445,80,0);

  //Mother
  gdx_frame(400,360,785,470,"Mother");
  gdx_label("ID #",408,385,0);
  gdx_label("0003",460,385,2);

  gdx_label("Given Name",408,410,0);
  gn3_text = gdx_textentry(499,395,200,0);
  gdx_label("Surname",408,435,0);
  sn3_text = gdx_textentry(499,420,200,0);
  gdx_label("Date of Birth",408,460,0);
  db3_text = gdx_textentry(499,445,80,0);

  button1 = gdx_imagebutton(5, 24, "close.xpm", destroy);
  button2 = gdx_imagebutton(35, 24, "filenew.xpm", cleardata);
  button3 = gdx_imagebutton(65, 24, "filesave.xpm", writedata);
  button4 = gdx_imagebutton(95, 24,"hnew.xpm",l_report);

  //menus

  menubar = gdx_menubar();

  menu1 = gdx_menu(menubar,"File");
  menu2 = gdx_menu(menubar,"Edit");
  menu3 = gdx_menu(menubar,"Help");

  menuitem1_menu1 = gdx_menuitem(menu1, "Quit", destroy);
  menuitem2_menu1 = gdx_menuitem(menu1, "Save", writedata);
  menuitem3_menu1 = gdx_menuitem(menu1, "Create HTML", l_report);

  menuitem1_menu2 = gdx_menuitem(menu2,"Clear Fields",cleardata);

  menuitem1_menu3 = gdx_menuitem(menu3,"About",about_message);

 
  gdx_main ();
  return 0;
}
